Index: /branches/version-2_11-dev/data/module/SOAP/Transport/HTTP.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Transport/HTTP.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Transport/HTTP.php	(revision 21410)
@@ -25,5 +25,5 @@
  *
  * @package  SOAP
- * @category Web Services
+ * @category Web_Services
  */
 
@@ -327,82 +327,78 @@
     function _parseResponse()
     {
-        if (!preg_match("/^(.*?)\r?\n\r?\n(.*)/s",
+        if (preg_match("/^(.*?)\r?\n\r?\n(.*)/s",
                        $this->incoming_payload,
                        $match)) {
-            $this->_raiseSoapFault('Invalid HTTP Response');
-            return false;
-        }
-
-        $this->response = $match[2];
-        // Find the response error, some servers response with 500 for
-        // SOAP faults.
-        $this->_parseHeaders($match[1]);
-
-        list(, $code, $msg) = sscanf($this->result_headers[0], '%s %s %s');
-        unset($this->result_headers[0]);
-
-        switch($code) {
-            case 100: // Continue
-                $this->incoming_payload = $match[2];
-                return $this->_parseResponse();
-            case 200:
-            case 202:
-                $this->incoming_payload = trim($match[2]);
-                if (!strlen($this->incoming_payload)) {
-                    /* Valid one-way message response. */
-                    return true;
+            $this->response = $match[2];
+            // Find the response error, some servers response with 500 for
+            // SOAP faults.
+            $this->_parseHeaders($match[1]);
+
+            list(, $code, $msg) = sscanf($this->result_headers[0], '%s %s %s');
+            unset($this->result_headers[0]);
+
+            switch($code) {
+                case 100: // Continue
+                    $this->incoming_payload = $match[2];
+                    return $this->_parseResponse();
+                case 400:
+                    $this->_raiseSoapFault("HTTP Response $code Bad Request");
+                    return false;
+                    break;
+                case 401:
+                    $this->_raiseSoapFault("HTTP Response $code Authentication Failed");
+                    return false;
+                    break;
+                case 403:
+                    $this->_raiseSoapFault("HTTP Response $code Forbidden");
+                    return false;
+                    break;
+                case 404:
+                    $this->_raiseSoapFault("HTTP Response $code Not Found");
+                    return false;
+                    break;
+                case 407:
+                    $this->_raiseSoapFault("HTTP Response $code Proxy Authentication Required");
+                    return false;
+                    break;
+                case 408:
+                    $this->_raiseSoapFault("HTTP Response $code Request Timeout");
+                    return false;
+                    break;
+                case 410:
+                    $this->_raiseSoapFault("HTTP Response $code Gone");
+                    return false;
+                    break;
+                default:
+                    if ($code >= 400 && $code < 500) {
+                        $this->_raiseSoapFault("HTTP Response $code Not Found, Server message: $msg");
+                        return false;
+                    }
+            }
+
+            $this->_parseEncoding($match[1]);
+
+            if ($this->result_content_type == 'application/dime') {
+                // XXX quick hack insertion of DIME
+                if (PEAR::isError($this->_decodeDIMEMessage($this->response, $this->headers, $this->attachments))) {
+                    // _decodeDIMEMessage already raised $this->fault
+                    return false;
                 }
-                break;
-            case 400:
-                $this->_raiseSoapFault("HTTP Response $code Bad Request");
+                $this->result_content_type = $this->headers['content-type'];
+            } elseif (stristr($this->result_content_type, 'multipart/related')) {
+                $this->response = $this->incoming_payload;
+                if (PEAR::isError($this->_decodeMimeMessage($this->response, $this->headers, $this->attachments))) {
+                    // _decodeMimeMessage already raised $this->fault
+                    return false;
+                }
+            } elseif ($this->result_content_type != 'text/xml') {
+                $this->_raiseSoapFault($this->response);
                 return false;
-            case 401:
-                $this->_raiseSoapFault("HTTP Response $code Authentication Failed");
-                return false;
-            case 403:
-                $this->_raiseSoapFault("HTTP Response $code Forbidden");
-                return false;
-            case 404:
-                $this->_raiseSoapFault("HTTP Response $code Not Found");
-                return false;
-            case 407:
-                $this->_raiseSoapFault("HTTP Response $code Proxy Authentication Required");
-                return false;
-            case 408:
-                $this->_raiseSoapFault("HTTP Response $code Request Timeout");
-                return false;
-            case 410:
-                $this->_raiseSoapFault("HTTP Response $code Gone");
-                return false;
-            default:
-                if ($code >= 400 && $code < 500) {
-                    $this->_raiseSoapFault("HTTP Response $code Not Found, Server message: $msg");
-                    return false;
-                }
-                break;
-        }
-
-        $this->_parseEncoding($match[1]);
-
-        if ($this->result_content_type == 'application/dime') {
-            // XXX quick hack insertion of DIME
-            if (PEAR::isError($this->_decodeDIMEMessage($this->response, $this->headers, $this->attachments))) {
-                // _decodeDIMEMessage already raised $this->fault
-                return false;
-            }
-            $this->result_content_type = $this->headers['content-type'];
-        } elseif (stristr($this->result_content_type, 'multipart/related')) {
-            $this->response = $this->incoming_payload;
-            if (PEAR::isError($this->_decodeMimeMessage($this->response, $this->headers, $this->attachments))) {
-                // _decodeMimeMessage already raised $this->fault
-                return false;
-            }
-        } elseif ($this->result_content_type != 'text/xml') {
-            $this->_raiseSoapFault($this->response);
-            return false;
-        }
-
-        // if no content, return false
-        return strlen($this->response) > 0;
+            }
+            // if no content, return false
+            return strlen($this->response) > 0;
+        }
+        $this->_raiseSoapFault('Invalid HTTP Response');
+        return false;
     }
 
@@ -562,16 +558,16 @@
         }
 
-        $headers = array();
-        $action = isset($options['soapaction']) ? $options['soapaction'] : '';
-        $headers['Content-Type'] = "text/xml; charset=$this->encoding";
-        $headers['SOAPAction'] = '"' . $action . '"';
-        if (isset($options['headers'])) {
-            $headers = array_merge($headers, $options['headers']);
-        }
-        foreach ($headers as $header => $value) {
-            $headers[$header] = $header . ': ' . $value;
-        }
-        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
-        curl_setopt($ch, CURLOPT_USERAGENT, $this->_userAgent);
+        if (!isset($options['soapaction'])) {
+            $options['soapaction'] = '';
+        }
+        if (!isset($options['headers']['Content-Type'])) {
+           $options['headers']['Content-Type'] = 'text/xml';
+        }
+        curl_setopt($ch, CURLOPT_HTTPHEADER,
+                    array('Content-Type: ' . $options['headers']['Content-Type']
+                         . ';charset=' . $this->encoding,
+                          'SOAPAction: "' . $options['soapaction'] . '"'));
+        curl_setopt($ch, CURLOPT_USERAGENT,
+                    $this->_userAgent);
 
         if ($this->timeout) {
Index: /branches/version-2_11-dev/data/module/SOAP/Transport/SMTP.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Transport/SMTP.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Transport/SMTP.php	(revision 21410)
@@ -152,5 +152,5 @@
             $val = new SOAP_Value('Message-ID', 'string', $headers['Message-ID']);
         } else {
-            $sval[] = new SOAP_Value('faultcode', 'QName', SOAP_BASE::SOAPENVPrefix().':Client');
+            $sval[] = new SOAP_Value('faultcode', 'QName', 'SOAP-ENV:Client');
             $sval[] = new SOAP_Value('faultstring', 'string', "couldn't send SMTP message to {$this->urlparts['path']}");
             $val = new SOAP_Value('Fault', 'Struct', $sval);
Index: /branches/version-2_11-dev/data/module/SOAP/WSDL.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/WSDL.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/WSDL.php	(revision 21410)
@@ -25,5 +25,5 @@
 require_once 'SOAP/Base.php';
 require_once 'SOAP/Fault.php';
-require_once 'HTTP/Request.php';
+require_once 'Request.php';
 
 define('WSDL_CACHE_MAX_AGE', 43200);
@@ -37,4 +37,5 @@
  *
  * @todo
+ * - add wsdl caching
  * - refactor namespace handling ($namespace/$ns)
  * - implement IDL type syntax declaration so we can generate WSDL
@@ -230,14 +231,14 @@
      *                                 service.
      */
-    function parseObject($wsdl_obj, $targetNamespace, $service_name,
+    function parseObject(&$wsdl_obj, $targetNamespace, $service_name,
                          $service_desc = '')
     {
-        $parser = new SOAP_WSDL_ObjectParser($wsdl_obj, $this,
-                                             $targetNamespace, $service_name,
-                                             $service_desc);
-
-        if ($parser->fault) {
-            $this->_raiseSoapFault($parser->fault);
-        }
+        $parser =& new SOAP_WSDL_ObjectParser($wsdl_obj, $this,
+                                              $targetNamespace, $service_name,
+                                              $service_desc);
+
+         if ($parser->fault) {
+             $this->_raiseSoapFault($parser->fault);
+         }
     }
 
@@ -313,5 +314,5 @@
             $opData = $this->bindings[$binding]['operations'][$operation];
         }
-        // Get operation data from porttype.
+        // get operation data from porttype
         $portType = $this->bindings[$binding]['type'];
         if (!$portType) {
@@ -405,31 +406,27 @@
         }
 
-        if (!isset($this->ns[$namespace])) {
-            return null;
-        }
-
-        $nsp = $this->ns[$namespace];
-        //if (!isset($this->elements[$nsp]))
-        //    $nsp = $this->namespaces[$nsp];
-        if (!isset($this->elements[$nsp][$datatype])) {
-            return null;
-        }
-
-        $checkmessages = array();
-        // Find what messages use this datatype.
-        foreach ($this->messages as $messagename => $message) {
-            foreach ($message as $part) {
-                if ($part['type'] == $datatype) {
-                    $checkmessages[] = $messagename;
-                    break;
-                }
-            }
-        }
-        // Find the operation that uses this message.
-        foreach($this->portTypes as $porttype) {
-            foreach ($porttype as $opname => $opinfo) {
-                foreach ($checkmessages as $messagename) {
-                    if ($opinfo['input']['message'] == $messagename) {
-                        return $opname;
+        if (isset($this->ns[$namespace])) {
+            $nsp = $this->ns[$namespace];
+            //if (!isset($this->elements[$nsp]))
+            //    $nsp = $this->namespaces[$nsp];
+            if (isset($this->elements[$nsp][$datatype])) {
+                $checkmessages = array();
+                // Find what messages use this datatype.
+                foreach ($this->messages as $messagename => $message) {
+                    foreach ($message as $part) {
+                        if ($part['type'] == $datatype) {
+                            $checkmessages[] = $messagename;
+                            break;
+                        }
+                    }
+                }
+                // Find the operation that uses this message.
+                foreach($this->portTypes as $porttype) {
+                    foreach ($porttype as $opname => $opinfo) {
+                        foreach ($checkmessages as $messagename) {
+                            if ($opinfo['input']['message'] == $messagename) {
+                                return $opname;
+                            }
+                        }
                     }
                 }
@@ -854,12 +851,5 @@
     }
 
-    /**
-     * @param QName $name  A parameter name.
-     * @param QName $type  A parameter type.
-     *
-     * @return array  A list of [type, array element type, array element
-     *                namespace, array length].
-     */
-    function getSchemaType($type, $name)
+    function getSchemaType($type, $name, $type_namespace)
     {
         // see if it's a complex type so we can deal properly with
@@ -869,25 +859,25 @@
             // look up the name in the wsdl and validate the type.
             foreach ($this->complexTypes as $types) {
-                if (isset($types[$type->name])) {
-                    if (isset($types[$type->name]['type'])) {
-                        list($arraytype_ns, $arraytype, $array_depth) = isset($types[$type->name]['arrayType'])
-                            ? $this->_getDeepestArrayType($types[$type->name]['namespace'], $types[$type->name]['arrayType'])
-                            : array($this->namespaces[$types[$type->name]['namespace']], null, 0);
-                        return array($types[$type->name]['type'], $arraytype, $arraytype_ns, $array_depth);
-                    }
-                    if (isset($types[$type->name]['arrayType'])) {
+                if (isset($types[$type])) {
+                    if (isset($types[$type]['type'])) {
+                        list($arraytype_ns, $arraytype, $array_depth) = isset($types[$type]['arrayType'])
+                            ? $this->_getDeepestArrayType($types[$type]['namespace'], $types[$type]['arrayType'])
+                            : array($this->namespaces[$types[$type]['namespace']], null, 0);
+                        return array($types[$type]['type'], $arraytype, $arraytype_ns, $array_depth);
+                    }
+                    if (isset($types[$type]['arrayType'])) {
                         list($arraytype_ns, $arraytype, $array_depth) =
-                            $this->_getDeepestArrayType($types[$type->name]['namespace'], $types[$type->name]['arrayType']);
+                            $this->_getDeepestArrayType($types[$type]['namespace'], $types[$type]['arrayType']);
                         return array('Array', $arraytype, $arraytype_ns, $array_depth);
                     }
-                    if (!empty($types[$type->name]['elements'][$name->name])) {
-                        $type->name = $types[$type->name]['elements']['type'];
-                        return array($type->name, null, $this->namespaces[$types[$type->name]['namespace']], null);
-                    }
-                    break;
-                }
-            }
-        }
-        if ($type && $type->namespace) {
+                    if (!empty($types[$type]['elements'][$name])) {
+                        $type = $types[$type]['elements']['type'];
+                        return array($type, null, $this->namespaces[$types[$type]['namespace']], null);
+                    }
+                    break;
+                }
+            }
+        }
+        if ($type && $type_namespace) {
             $arrayType = null;
             // XXX TODO:
@@ -895,28 +885,28 @@
             // types in wsdl need to do a generalized function to figure out
             // complex types
-            $p = $this->ns[$type->namespace];
-            if ($p && !empty($this->complexTypes[$p][$type->name])) {
-                if ($arrayType = $this->complexTypes[$p][$type->name]['arrayType']) {
-                    $type->name = 'Array';
-                } elseif ($this->complexTypes[$p][$type->name]['order'] == 'sequence' &&
-                          array_key_exists('elements', $this->complexTypes[$p][$type->name])) {
-                    reset($this->complexTypes[$p][$type->name]['elements']);
+            $p = $this->ns[$type_namespace];
+            if ($p && !empty($this->complexTypes[$p][$type])) {
+                if ($arrayType = $this->complexTypes[$p][$type]['arrayType']) {
+                    $type = 'Array';
+                } elseif ($this->complexTypes[$p][$type]['order'] == 'sequence' &&
+                          array_key_exists('elements', $this->complexTypes[$p][$type])) {
+                    reset($this->complexTypes[$p][$type]['elements']);
                     // assume an array
-                    if (count($this->complexTypes[$p][$type->name]['elements']) == 1) {
-                        $arg = current($this->complexTypes[$p][$type->name]['elements']);
+                    if (count($this->complexTypes[$p][$type]['elements']) == 1) {
+                        $arg = current($this->complexTypes[$p][$type]['elements']);
                         $arrayType = $arg['type'];
-                        $type->name = 'Array';
+                        $type = 'Array';
                     } else {
-                        foreach ($this->complexTypes[$p][$type->name]['elements'] as $element) {
-                            if ($element['name'] == $type->name) {
+                        foreach ($this->complexTypes[$p][$type]['elements'] as $element) {
+                            if ($element['name'] == $type) {
                                 $arrayType = $element['type'];
-                                $type->name = $element['type'];
+                                $type = $element['type'];
                             }
                         }
                     }
                 } else {
-                    $type->name = 'Struct';
-                }
-                return array($type->name, $arrayType, $type->namespace, null);
+                    $type = 'Struct';
+                }
+                return array($type, $arrayType, $type_namespace, null);
             }
         }
@@ -1038,7 +1028,12 @@
             // Try to retrieve WSDL from cache
             $cachename = $this->_cacheDir() . '/' . md5($wsdl_fname). ' .wsdl';
-            if (file_exists($cachename) &&
-                $file_data = file_get_contents($cachename)) {
-                $md5_wsdl = md5($file_data);
+            if (file_exists($cachename)) {
+                $wf = fopen($cachename, 'rb');
+                if ($wf) {
+                    // Reading cached file
+                    $file_data = fread($wf, filesize($cachename));
+                    $md5_wsdl = md5($file_data);
+                    fclose($wf);
+                }
                 if ($cache) {
                     if ($cache != $md5_wsdl) {
@@ -1048,26 +1043,26 @@
                     $fi = stat($cachename);
                     $cache_mtime = $fi[8];
+                    //print cache_mtime, time()
                     if ($cache_mtime + $this->_cacheMaxAge < time()) {
-                        // Expired, refetch.
-                        $md5_wsdl = '';
-                    }
-                }
-            }
-        }
-
-        // Not cached or not using cache. Retrieve WSDL from URL
+                        // expired
+                        $md5_wsdl = ''; // refetch
+                    }
+                }
+            }
+        }
+
         if (!$md5_wsdl) {
-            // Is it a local file?
-            if (strpos($wsdl_fname, 'file://') === 0) {
-                $wsdl_fname = substr($wsdl_fname, 7);
+            // Not cached or not using cache. Retrieve WSDL from URL
+
+            // is it a local file?
+            // this section should be replace by curl at some point
+            if (!preg_match('/^(https?|file):\/\//', $wsdl_fname)) {
                 if (!file_exists($wsdl_fname)) {
-                    return $this->_raiseSoapFault('Unable to read local WSDL file', $wsdl_fname);
+                    return $this->_raiseSoapFault("Unable to read local WSDL $wsdl_fname", $wsdl_fname);
                 }
                 $file_data = file_get_contents($wsdl_fname);
-            } elseif (!preg_match('|^https?://|', $wsdl_fname)) {
-                return $this->_raiseSoapFault('Unknown schema of WSDL URL', $wsdl_fname);
             } else {
                 $uri = explode('?', $wsdl_fname);
-                $rq = new HTTP_Request($uri[0], $proxy_params);
+                $rq =& new HTTP_Request($uri[0], $proxy_params);
                 // the user agent HTTP_Request uses fouls things up
                 if (isset($uri[1])) {
@@ -1079,12 +1074,9 @@
                     isset($proxy_params['proxy_user']) &&
                     isset($proxy_params['proxy_pass'])) {
-                    $rq->setProxy($proxy_params['proxy_host'],
-                                  $proxy_params['proxy_port'],
-                                  $proxy_params['proxy_user'],
-                                  $proxy_params['proxy_pass']);
+                    $rq->setProxy($proxy_params['proxy_host'], $proxy_params['proxy_port'],
+                                  $proxy_params['proxy_user'], $proxy_params['proxy_pass']);
                 } elseif (isset($proxy_params['proxy_host']) &&
                           isset($proxy_params['proxy_port'])) {
-                    $rq->setProxy($proxy_params['proxy_host'],
-                                  $proxy_params['proxy_port']);
+                    $rq->setProxy($proxy_params['proxy_host'], $proxy_params['proxy_port']);
                 }
 
@@ -1107,9 +1099,7 @@
             }
         }
-
         if ($this->_cacheUse && $cache && $cache != $md5_wsdl) {
-            return $this->_raiseSoapFault('WSDL Checksum error!', $wsdl_fname);
-        }
-
+            return $this->_raiseSoapFault("WSDL Checksum error!", $wsdl_fname);
+        }
         return $file_data;
     }
@@ -1985,5 +1975,5 @@
      *                                 <service>.
      */
-    function SOAP_WSDL_ObjectParser($objects, &$wsdl, $targetNamespace,
+    function SOAP_WSDL_ObjectParser(&$objects, &$wsdl, $targetNamespace,
                                     $service_name, $service_desc = '')
     {
@@ -1996,5 +1986,5 @@
 
         // Parse each web service object
-        $wsdl_ref = is_array($objects) ? $objects : array($objects);
+        $wsdl_ref = (is_array($objects)? $objects : array(&$objects));
 
         foreach ($wsdl_ref as $ref_item) {
@@ -2031,5 +2021,5 @@
         $this->wsdl->namespaces[$this->tnsPrefix] = 'urn:' . $service_name;                 // Target namespace
         $this->wsdl->namespaces['xsd'] = array_search('xsd', $this->_namespaces);           // XML Schema
-        $this->wsdl->namespaces[SOAP_BASE::SOAPENCPrefix()] = array_search(SOAP_BASE::SOAPENCPrefix(), $this->_namespaces); // SOAP types
+        $this->wsdl->namespaces['SOAP-ENC'] = array_search('SOAP-ENC', $this->_namespaces); // SOAP types
 
         // XXX Refactor $namespace/$ns for Shane :-)
@@ -2050,5 +2040,5 @@
      * @param string $service_name     Name of the WSDL <service>.
      */
-    function _parse($object, $schemaNamespace, $service_name)
+    function _parse(&$object, $schemaNamespace, $service_name)
     {
         // Create namespace prefix for the schema
@@ -2109,8 +2099,4 @@
         // *** <wsdl:message> ***
         foreach ($object->__dispatch_map as $operationName => $messages) {
-            // We need at least 'in' and 'out' parameters.
-            if (!isset($messages['in']) || !isset($messages['out'])) {
-                return $this->_raiseSoapFault('The dispatch map for the method "' . $operationName . '" is missing an "in" or "out" definition.', 'urn:' . get_class($object));
-            }
             foreach ($messages as $messageType => $messageParts) {
                 unset($thisMessage);
